#include <algorithm> // 'std::sort', etc.
#include <cmath> // '::log'
#include <iostream>
#include <numeric> // 'std::accumulate', etc.
#include <vector>

#include "Sort_illustration.h"

int main(int argc, char** argv) {
    int n = 10000;
    Sort_illustration si(n);
    std::cout << si.sort(Sort_illustration::Quick) << '\n';
    std::cout << "n*log(n): " << n * ::log(n) << std::endl;

    short tab[] = {13, 7, 6, 4, 12, 11, 8, 3};
    std::vector<short> vector(tab, tab + 8);
    for (int i = 0; i < vector.size(); i++) std::cout << "-" << vector[i];
    std::cout << std::endl;
    std::sort(vector.begin(), vector.end());
    for (int i = 0; i < vector.size(); i++) std::cout << "-" << vector[i];
    std::cout << std::endl;

    std::cout << std::accumulate(vector.begin(), vector.end(), 0) << std::endl;

    std::pair<std::string, std::string> identity("Barbier", "Franck");
    std::cout << identity.second << ' ' << identity.first << std::endl;

    std::less<std::string> f;
    std::cout << f("Barbier", "Franck") << std::endl;

    return 0;
}

